# Утилиты Chrome

Небольшое дополнение, в которое мы будем добавлять улучшения для браузера Chrome.

Это дополнение работает только на NVDA версии 2019.3 и выше.

Теперь он поддерживает все свои функции во всех трех вариантах - Final, Beta и Canary.

## Дополнительные клавиатурные команды:

Все дополнительные клавиатурные команды можно изменить в диалоговом окне "Жесты ввода NVDA".

В диалоговом окне "Жесты ввода NVDA" они будут находиться в категории "Утилиты Chrome".

Обратите внимание, что для появления этой категории диалоговое окно "Жесты ввода" должно быть вызвано при открытом и сфокусированном браузере Chrome.

* Shift+F4: Включение и выключение циклического просмотра.
* NVDA+F6: Открывает диалог списка вкладок.
* F7: Показывает историю посещенных страниц в обратном направлении.
* F8: Показывает историю посещенных страниц вперед.
* F9: включение и выключение режима чтения.
* Shift+F9: Запуск непрерывного чтения в режиме чтения.

### Циклическая навигация

Теперь мы можем использовать циклическую навигацию в Chrome, хорошо известную по другим программам чтения с экрана.

Циклическая навигация заставляет программу чтения с экрана перейти к началу страницы или наоборот, когда больше нет элементов нужного типа, в зависимости от используемого шрифта быстрой навигации. Например, если вы нажмете h для просмотра рубрик, а больше рубрик не будет, NVDA перейдет к верхней части страницы и вернет вас к первой.

Включить или отключить циклическую навигацию можно с помощью Shift+F4.

После включения навигация по сайту осуществляется с помощью однобуквенных навигационных клавиш.

Внимание!

Если я остановлюсь на том, что уже существует дополнение, размещенное на официальном сайте сообщества NVDA на испанском языке, которое заключается в следующем:

<https://nvda.es/2019/01/25/screen-rapping-navegacion-ciclica/>

или из авторского репозитория на GitHub:

<https://github.com/hamadatrichine/nvda-screen-rapping>

Ну, это дополнение устарело, и нам пришлось бы изменить манифест, чтобы заставить его работать, используя показатели совместимости с последними версиями NVDA, и мне кажется, что автор больше не продолжает его разработку 2 года назад.

Поэтому я хочу предупредить, что если мы собираемся использовать эту функцию в Chrome, то это рекомендуется только в том случае, если мы установили дополнение Screen Rapping, отключите его или удалите, если мы не собираемся использовать его в другом месте, и используйте функцию, которая уже есть в моем дополнении.

Если мы собираемся использовать циклическую навигацию в других документах или браузерах, то я рекомендую использовать надстройку Screen Rapping и забыть о функции, которая есть в моей надстройке.

Это на вкус каждого, но Screen Rapping является дополнением, которое не обновляется и малоизвестно, и я решил, что будет правильно включить его функцию в дополнение Chrome Utilities с согласия Хамады Трихина на использование его кода.

И, наконец, в случае, если у нас есть другое дополнение, которое выполняет ту же функцию, пожалуйста, я рекомендую вам использовать его дополнение и забыть о функции, которая есть в моем дополнении.

### Управление вкладками

В браузере Chrome мы можем менять области с помощью F6, чтобы попасть в область вкладок и перемещаться по ним с помощью стрелок, а также поверх нужной нам вкладки, если мы нажмем клавишу приложения, появится меню с различными опциями, которые мы можем выполнить на вкладке.

Мы также можем быстро переключаться между вкладками с помощью комбинации CTRL+1 - 9, но все становится сложнее, когда у нас больше вкладок.

Теперь дополнение будет иметь комбинацию, которая отобразит диалог со всеми открытыми вкладками, отсортированными в том порядке, в котором они были открыты.

Чтобы открыть этот диалог, нужно нажать NVDA+F6.

Диалог имеет две области, одна из которых содержит список вкладок, а другая - кнопки, мы можем перемещаться между различными областями с помощью вкладок или горячих клавиш.

В списке, если мы нажмем клавишу Enter, это приведет нас к переходу на вкладку, которую мы выбрали в данный момент.

У нас есть 4 кнопки, а именно:

* Нажмите кнопку "Влево", которая приведет нас на вкладку, выбранную в списке.
* Нажмите кнопку "Вправо", которая отобразит опции для вкладки, выбранной нами в списке.
* Новая вкладка, эта кнопка откроет новую вкладку, где мы сможем начать с нуля, она оставит фокус на панели направлений, чтобы мы искали или вводили направление, которое нам нужно.
* Закрыть, эта кнопка закроет диалог и оставит нас на странице, с которой был вызван диалог.

Следует отметить, что диалоговое окно вкладки можно закрыть с помощью соответствующей кнопки, нажатием клавиши ESC или потерей фокуса.

Последнее означает, что при открытом диалоговом окне вкладок, если мы вернемся в браузер, диалог списка вкладок автоматически закроется.

Это гарантирует, что когда мы снова вызываем диалог, он получает правильную информацию для каждого раза, когда он был вызван.
 
### Быстрая история посещенных страниц

Мы включили возможность быстрого доступа к истории посещенных страниц как назад, так и вперед.

Для доступа к этой истории используйте F7 и F8.

Позвольте мне привести пример для лучшего понимания.

Если мы откроем браузер и по умолчанию у нас не открыто ни одной страницы, мы перейдем на сайт www.google.com.

После загрузки страницы нажимаем CTRL+L и ставим www.nvda.es, теперь, если мы нажмем F7, то увидим, что появилось меню со страницей Google в истории. Если мы выберем эту страницу Google, будет загружена именно эта страница.

Теперь, если мы нажмем F8, то увидим, что у нас в истории появилась страница NVDA на испанском языке.

Эти истории как назад, так и вперед относятся к вкладке, на которой в данный момент находится фокус, обновляя историю для каждой вкладки.

Это полезно при просмотре многих страниц в одном сеансе на одной вкладке.

Внимание, история очищается при закрытии Chrome.

### Улучшенный режим чтения

Сам по себе Chrome не имеет такого режима, как другие браузеры.

Если мы хотим иметь эту функцию, нам придется активировать ее вручную, прежде чем мы сможем ее использовать.

Чтобы активировать эту функцию, поместим себя в адресную строку и напишем следующее:

chrome://flags

*** Начиная с Chrome 100, мы должны снова активировать флаги для этой версии. ***

Для этого на экране флагов перейдите к заголовку уровня 3, в котором говорится:

-Временно не использовать флаги M100.

Прокрутите вниз до комбинированного поля и установите для него значение Enable. Нажимайте B до тех пор, пока не дойдете до кнопки перезапуска, а когда вернетесь на экран флагов, продолжайте выполнять действия.

Если он относится к версии до 100, продолжайте с этого места.

Нажимаем Enter и в поле поиска Search flags пишем следующее:

режим считывания

Когда мы напишем его, мы услышим, что есть результат, поэтому мы будем табулировать, пока не услышим следующее:

-#enable-reader-mode

Затем еще раз нажимаем на вкладку и попадаем в комбинированное окно, в котором нужно выбрать опцию Enable.

Теперь вернемся к кнопке Relaunch, нажмем ее, и при следующем перезапуске браузера у нас будет активирован режим чтения.

Когда мы заходим на страницу, которая позволяет режим чтения, будьте осторожны, не все из них это делают. Мы можем активировать этот режим, чтобы убрать все, что мешает, т.е. отображать только содержимое страницы без внешнего вида или рекламы, сохраняя только текст и изображения для удобства чтения, это можно сделать двумя способами:

1º В меню Chrome, двигаясь вверх или вниз, пока не услышим Активировать/деактивировать режим чтения, мы перейдем в режим чтения, если в меню не отображается эта опция, значит, это страница, на которую мы не допущены.

2º Как только мы окажемся на странице, мы можем нажать F6 и две вкладки, чтобы достичь кнопки с надписью Активировать/деактивировать режим чтения, если мы нажмем ее, мы войдем в этот режим. Если эта кнопка не появляется, это означает, что страница, на которой мы находимся, не позволяет это сделать.

Хотя кажется, что мы мало используем этот режим чтения, мне не хватает быстрого сочетания клавиш, чтобы включить или отключить этот режим или предупредить меня, если страница не позволяет это сделать.

Теперь с дополнением, если мы нажмем F9, то активируем режим чтения.

Если страница, на которой мы находимся, не позволяет использовать этот режим, мы получим предупреждение с сообщением.

Если страница позволяет, она переходит в режим чтения, предупреждая нас сообщением.

Если мы нажмем F9, когда мы уже находимся в режиме чтения, он выйдет из него, а также предупредит нас о выходе из этого режима.

### Непрерывное чтение в режиме чтения

Если мы нажмем Shift+F9, когда режим чтения активирован, NVDA начнет читать страницу с того места, где находится курсор.

Если мы нажмем Ctrl, то прекратим чтение.

### Быстрая история посещенных страниц

Мы включили возможность быстрого доступа к истории посещенных страниц вперед или назад.

Для доступа к этой истории мы будем использовать F7 и F8.

Позвольте мне привести пример для лучшего понимания.

Если мы откроем браузер и по умолчанию у нас не открыто ни одной страницы, мы перейдем на сайт www.google.com.

После загрузки страницы нажимаем CTRL+L и ставим www.nvda.es, теперь, если мы нажмем F7, то увидим, что появилось меню со страницей Google в истории. Если мы выберем эту страницу Google, будет загружена именно эта страница.

Теперь, если мы нажмем F8, то увидим, что у нас в истории появилась страница NVDA на испанском языке.

Эти истории как назад, так и вперед относятся к вкладке, на которой в данный момент находится фокус, обновляя историю для каждой вкладки.

Это полезно при просмотре многих страниц в одном сеансе на одной вкладке.

Внимание, история очищается при закрытии Chrome.

### Улучшенный режим чтения

Chrome сам по себе не имеет такого режима, как другие браузеры.

### Панель опций

Начиная с версии 0.7 дополнения, у нас появится новая область в Preferences / Options и ищите Chrome Utilities.

В этом разделе опций я буду добавлять опции, которые я считаю интересными для браузера.

Чтобы иметь возможность видеть эту категорию, нам придется вызвать опции NVDA из браузера Chrome, иначе она не будет видна.

На данный момент у нас есть следующий вариант:

* Открывайте окна Chrome в максимальном размере.

Если мы установим этот флажок, все окна Chrome по умолчанию будут открываться в максимальном размере.

## Переводчики и соавторы:

* Французский: Реми Руис
* Португальский: Анжело Мигель Абрантеш.
* Арабский: Вафик Тахер
* Турецкий: : умут коркмаз
* Русский: Валентин Куприянов

## Журнал изменений.
## Версия 0.101.

* Адаптация к новому интерфейсу.
* Добавлена документация о том, как активировать режим Reader Mode из этой версии.

## Версия 0.100.

* Адаптация к новому интерфейсу.
* Совместимость с NVDA 2022.1.

## Версия 0.94.

* Изменена номенклатура версий для соответствия версии Chrome.

Версия будет изменена при нарушении совместимости. Последняя измененная версия - Chrome версии 0.94.

* Добавлен турецкий язык.

## Версия 0.8.

* Внутренние изменения для адаптации к новому API в NVDA 2021.1 и поддержания обратной совместимости.

* Поддержка Google Chrome 91

## Версия 0.7.

* Добавлена возможность открывать Chrome всегда в максимальном размере.

## Версия 0.6.

* Начальная версия.